diff -Naurp open-iscsi-2.0-868-test1/include/fw_context.h open-iscsi-2.0-868-test1.work/include/fw_context.h
--- open-iscsi-2.0-868-test1/include/fw_context.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/include/fw_context.h	2008-12-17 02:43:41.000000000 -0600
@@ -21,7 +21,7 @@
 #ifndef FWPARAM_CONTEXT_H_
 #define FWPARAM_CONTEXT_H_
 
-#include "list.h"
+#include "iscsi_list.h"
 
 struct boot_context {
 	struct list_head list;
@@ -58,5 +58,6 @@ extern int fw_get_entry(struct boot_cont
 extern void fw_print_entry(struct boot_context *context);
 extern int fw_get_targets(struct list_head *list);
 extern void fw_free_targets(struct list_head *list);
+extern int fwparam_ibft_sysfs(struct boot_context *context, const char *filepath);
 
 #endif /* FWPARAM_CONTEXT_H_ */
diff -Naurp open-iscsi-2.0-868-test1/include/list.h open-iscsi-2.0-868-test1.work/include/list.h
--- open-iscsi-2.0-868-test1/include/list.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/include/list.h	1969-12-31 18:00:00.000000000 -0600
@@ -1,93 +0,0 @@
-#ifndef __LIST_H__
-#define __LIST_H__
-
-#include <stddef.h>
-/* taken from linux kernel */
-
-#undef offsetof
-#ifdef __compiler_offsetof
-#define offsetof(TYPE,MEMBER) __compiler_offsetof(TYPE,MEMBER)
-#else
-#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
-#endif
-
-#define container_of(ptr, type, member) ({			\
-        const typeof( ((type *)0)->member ) *__mptr = (ptr);	\
-        (type *)( (char *)__mptr - offsetof(type,member) );})
-
-struct list_head {
-	struct list_head *next, *prev;
-};
-
-#define LIST_HEAD_INIT(name) { &(name), &(name) }
-
-#define LIST_HEAD(name) \
-	struct list_head name = LIST_HEAD_INIT(name)
-
-static inline void INIT_LIST_HEAD(struct list_head *list)
-{
-	list->next = list;
-	list->prev = list;
-}
-
-static inline int list_empty(const struct list_head *head)
-{
-	return head->next == head;
-}
-
-#define list_entry(ptr, type, member) \
-	container_of(ptr, type, member)
-
-#define list_for_each(pos, head) \
-	for (pos = (head)->next; pos != (head); pos = pos->next)
-
-#define list_for_each_entry(pos, head, member)				\
-	for (pos = list_entry((head)->next, typeof(*pos), member);	\
-	     &pos->member != (head);				 	\
-	     pos = list_entry(pos->member.next, typeof(*pos), member))
-
-#define list_for_each_entry_safe(pos, n, head, member)			\
-	for (pos = list_entry((head)->next, typeof(*pos), member),	\
-		n = list_entry(pos->member.next, typeof(*pos), member);	\
-	     &pos->member != (head); 					\
-	     pos = n, n = list_entry(n->member.next, typeof(*n), member))
-
-static inline void __list_add(struct list_head *new,
-			      struct list_head *prev,
-			      struct list_head *next)
-{
-	next->prev = new;
-	new->next = next;
-	new->prev = prev;
-	prev->next = new;
-}
-
-static inline void list_add(struct list_head *new, struct list_head *head)
-{
-	__list_add(new, head, head->next);
-}
-
-static inline void list_add_tail(struct list_head *new, struct list_head *head)
-{
-	__list_add(new, head->prev, head);
-}
-
-static inline void __list_del(struct list_head * prev, struct list_head * next)
-{
-	next->prev = prev;
-	prev->next = next;
-}
-
-static inline void list_del(struct list_head *entry)
-{
-	__list_del(entry->prev, entry->next);
-	entry->next = entry->prev = NULL;
-}
-
-static inline void list_del_init(struct list_head *entry)
-{
-	__list_del(entry->prev, entry->next);
-	INIT_LIST_HEAD(entry);
-}
-
-#endif
diff -Naurp open-iscsi-2.0-868-test1/usr/actor.c open-iscsi-2.0-868-test1.work/usr/actor.c
--- open-iscsi-2.0-868-test1/usr/actor.c	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/actor.c	2008-12-16 11:11:51.000000000 -0600
@@ -19,7 +19,6 @@
 #include <inttypes.h>
 #include "actor.h"
 #include "log.h"
-#include "list.h"
 
 static LIST_HEAD(pend_list);
 static LIST_HEAD(poll_list);
diff -Naurp open-iscsi-2.0-868-test1/usr/actor.h open-iscsi-2.0-868-test1.work/usr/actor.h
--- open-iscsi-2.0-868-test1/usr/actor.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/actor.h	2008-12-16 11:11:02.000000000 -0600
@@ -20,7 +20,7 @@
 #define ACTOR_H
 
 #include "types.h"
-#include "list.h"
+#include "iscsi_list.h"
 
 #define ACTOR_RESOLUTION	250	/* in millis */
 #define ACTOR_MAX_LOOPS		1
diff -Naurp open-iscsi-2.0-868-test1/usr/config.h open-iscsi-2.0-868-test1.work/usr/config.h
--- open-iscsi-2.0-868-test1/usr/config.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/config.h	2008-12-16 11:11:02.000000000 -0600
@@ -24,7 +24,7 @@
 #include <net/if.h>
 #include "types.h"
 #include "auth.h"	/* for the username and password sizes */
-#include "list.h"
+#include "iscsi_list.h"
 
 /* ISIDs now have a typed naming authority in them.  We use an OUI */
 #define DRIVER_ISID_0  0x00
diff -Naurp open-iscsi-2.0-868-test1/usr/initiator.h open-iscsi-2.0-868-test1.work/usr/initiator.h
--- open-iscsi-2.0-868-test1/usr/initiator.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/initiator.h	2008-12-16 11:11:02.000000000 -0600
@@ -30,7 +30,7 @@
 #include "mgmt_ipc.h"
 #include "config.h"
 #include "actor.h"
-#include "list.h"
+#include "iscsi_list.h"
 
 #define ISCSI_CONFIG_ROOT	"/etc/iscsi/"
 
diff -Naurp open-iscsi-2.0-868-test1/usr/iscsiadm.c open-iscsi-2.0-868-test1.work/usr/iscsiadm.c
--- open-iscsi-2.0-868-test1/usr/iscsiadm.c	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/iscsiadm.c	2008-12-16 11:11:02.000000000 -0600
@@ -37,7 +37,7 @@
 #include "transport.h"
 #include "version.h"
 #include "iscsi_sysfs.h"
-#include "list.h"
+#include "iscsi_list.h"
 #include "iscsi_settings.h"
 #include "fw_context.h"
 
diff -Naurp open-iscsi-2.0-868-test1/usr/iscsi_list.h open-iscsi-2.0-868-test1.work/usr/iscsi_list.h
--- open-iscsi-2.0-868-test1/usr/iscsi_list.h	1969-12-31 18:00:00.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/iscsi_list.h	2008-12-16 11:11:02.000000000 -0600
@@ -0,0 +1,93 @@
+#ifndef __LIST_H__
+#define __LIST_H__
+
+#include <stddef.h>
+/* taken from linux kernel */
+
+#undef offsetof
+#ifdef __compiler_offsetof
+#define offsetof(TYPE,MEMBER) __compiler_offsetof(TYPE,MEMBER)
+#else
+#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
+#endif
+
+#define container_of(ptr, type, member) ({			\
+        const typeof( ((type *)0)->member ) *__mptr = (ptr);	\
+        (type *)( (char *)__mptr - offsetof(type,member) );})
+
+struct list_head {
+	struct list_head *next, *prev;
+};
+
+#define LIST_HEAD_INIT(name) { &(name), &(name) }
+
+#define LIST_HEAD(name) \
+	struct list_head name = LIST_HEAD_INIT(name)
+
+static inline void INIT_LIST_HEAD(struct list_head *list)
+{
+	list->next = list;
+	list->prev = list;
+}
+
+static inline int list_empty(const struct list_head *head)
+{
+	return head->next == head;
+}
+
+#define list_entry(ptr, type, member) \
+	container_of(ptr, type, member)
+
+#define list_for_each(pos, head) \
+	for (pos = (head)->next; pos != (head); pos = pos->next)
+
+#define list_for_each_entry(pos, head, member)				\
+	for (pos = list_entry((head)->next, typeof(*pos), member);	\
+	     &pos->member != (head);				 	\
+	     pos = list_entry(pos->member.next, typeof(*pos), member))
+
+#define list_for_each_entry_safe(pos, n, head, member)			\
+	for (pos = list_entry((head)->next, typeof(*pos), member),	\
+		n = list_entry(pos->member.next, typeof(*pos), member);	\
+	     &pos->member != (head); 					\
+	     pos = n, n = list_entry(n->member.next, typeof(*n), member))
+
+static inline void __list_add(struct list_head *new,
+			      struct list_head *prev,
+			      struct list_head *next)
+{
+	next->prev = new;
+	new->next = next;
+	new->prev = prev;
+	prev->next = new;
+}
+
+static inline void list_add(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head, head->next);
+}
+
+static inline void list_add_tail(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head->prev, head);
+}
+
+static inline void __list_del(struct list_head * prev, struct list_head * next)
+{
+	next->prev = prev;
+	prev->next = next;
+}
+
+static inline void list_del(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+	entry->next = entry->prev = NULL;
+}
+
+static inline void list_del_init(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+	INIT_LIST_HEAD(entry);
+}
+
+#endif
diff -Naurp open-iscsi-2.0-868-test1/usr/Makefile open-iscsi-2.0-868-test1.work/usr/Makefile
--- open-iscsi-2.0-868-test1/usr/Makefile	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/usr/Makefile	2008-12-16 11:14:58.000000000 -0600
@@ -30,7 +30,7 @@ endif
 
 OPTFLAGS ?= -O2 -g
 WARNFLAGS ?= -Wall -Wstrict-prototypes
-CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -D$(OSNAME) $(IPC_CFLAGS)
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../include -I. -D$(OSNAME) $(IPC_CFLAGS)
 PROGRAMS = iscsid iscsiadm iscsistart
 
 # sources shared between iscsid, iscsiadm and iscsistart
diff -Naurp open-iscsi-2.0-868-test1/utils/fwparam_ibft/fw_entry.c open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fw_entry.c
--- open-iscsi-2.0-868-test1/utils/fwparam_ibft/fw_entry.c	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fw_entry.c	2008-12-17 02:20:49.000000000 -0600
@@ -40,7 +40,7 @@ int fw_get_entry(struct boot_context *co
 
 	ret = fwparam_ppc_boot_info(context);
 	if (ret)
-		ret = fwparam_ibft_sysfs_boot_info(context);
+		ret = fwparam_ibft_sysfs(context, NULL);
 
 	return ret;
 }
diff -Naurp open-iscsi-2.0-868-test1/utils/fwparam_ibft/fwparam.h open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fwparam.h
--- open-iscsi-2.0-868-test1/utils/fwparam_ibft/fwparam.h	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fwparam.h	2008-12-17 02:24:52.000000000 -0600
@@ -24,7 +24,7 @@
 
 struct boot_context;
 
-int fwparam_ibft_sysfs_boot_info(struct boot_context *context);
+int fwparam_ibft_sysfs(struct boot_context *context, const char *filepath);
 int fwparam_ibft_sysfs_get_targets(struct list_head *list);
 int fwparam_ppc_boot_info(struct boot_context *context);
 int fwparam_ppc_get_targets(struct list_head *list);
diff -Naurp open-iscsi-2.0-868-test1/utils/fwparam_ibft/fwparam_ibft_sysfs.c open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fwparam_ibft_sysfs.c
--- open-iscsi-2.0-868-test1/utils/fwparam_ibft/fwparam_ibft_sysfs.c	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/fwparam_ibft_sysfs.c	2008-12-17 02:25:59.000000000 -0600
@@ -286,7 +286,7 @@ static void deallocate_lists(void)
 
 }
 
-int fwparam_ibft_sysfs_boot_info(struct boot_context *context)
+int fwparam_ibft_sysfs(struct boot_context *context, const char *filepath)
 {
 	char initiator_dir[FILENAMESZ];
 	char *root_sysfs = IBFT_SYSFS_ROOT;
diff -Naurp open-iscsi-2.0-868-test1/utils/fwparam_ibft/Makefile open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/Makefile
--- open-iscsi-2.0-868-test1/utils/fwparam_ibft/Makefile	2008-12-16 11:10:54.000000000 -0600
+++ open-iscsi-2.0-868-test1.work/utils/fwparam_ibft/Makefile	2008-12-16 11:11:02.000000000 -0600
@@ -37,7 +37,7 @@ endif # NOL
 
 OPTFLAGS ?= -O2 -g -fPIC
 WARNFLAGS ?= -Wall -Wstrict-prototypes
-CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -I../../include -I../../usr
 
 all: $(LIB)
 
